scapbc <- function(s111, s101, s011, s001, r111, r101, r011, r001, s112, s102, s012, s002, r112, r102, r012, r002, alpha = 0.05)
{
  if (s111 < 0 | s101 < 0 | s011 < 0 | s001 < 0 | r111 < 0 | r101 < 0 | r011 < 0 | r001 < 0)
    {
      stop("All observed frequencies must be positive integer values. Introduces new values \n")
    }
    
  if (s112 < 0 | s102 < 0 | s012 < 0 | s002 < 0 | r112 < 0 | r102 < 0 | r012 < 0 | r002 < 0)
    {
      stop("All observed frequencies must be positive integer values. Introduces new values \n")
    }

  if (alpha >= 1 | alpha <= 0)
    {
      stop("Alpha error level must be a value between 0 and 1. Introduces a new value \n")
    }

  if (abs(s111 - trunc (s111)) > 0  | abs(s101 - trunc (s101)) > 0  | abs(s011 - trunc (s011)) > 0  | abs(s001 - trunc (s001)) > 0  | abs(r111 - trunc (r111)) > 0  | abs(r101 - trunc (r101)) > 0  | abs(r011 - trunc (r011)) > 0  | abs(r001 - trunc (r001)) > 0)
    {
      stop("All observed frequencies must be positive integer values. Introduces new values \n")
    }
    
  if (abs(s112 - trunc (s112)) > 0  | abs(s102 - trunc (s102)) > 0  | abs(s012 - trunc (s012)) > 0  | abs(s002 - trunc (s002)) > 0  | abs(r112 - trunc (r112)) > 0  | abs(r102 - trunc (r102)) > 0  | abs(r012 - trunc (r012)) > 0  | abs(r002 - trunc (r002)) > 0)
    {
      stop("All observed frequencies must be positive integer values. Introduces new values \n")
    }

  if ((s101 + s011 + r101 + r011) == 0 & (s102 + s012 + r102 + r012) == 0)
    {
      stop("There are many frequencies equal to 0. Introduces new values \n")
    }

  z  = qnorm(1 - alpha / 2, 0 ,1)
  
  s1 <- s001 + s011 + s101 + s111
  
  r1 <- r001 + r011 + r101 + r111
  
  n1 <- s1 + r1
  
  s2 <- s002 + s012 + s102 + s112

  r2 <- r002 + r012 + r102 + r112

  n2 <- s2 + r2
  
  n <- n1 + n2
   
  Sensi1 <- expression((h1 * (f111 + f101) + (1 - h1) * (f112 + f102)) / (h1 * (f111 + f101 + f011 + f001) + (1 - h1) * (f112 + f102 + f012 + f002)))
  
  Speci1 <- expression((h1 * (g001 + g011) + (1 - h1) * (g002 + g012)) / (h1 * (g111 + g101 + g011 + g001) + (1 - h1) * (g112 + g102 + g012 + g002)))
  
  Sensi2 <- expression((h1 * (f111 + f011) + (1 - h1) * (f112 + f012)) / (h1 * (f111 + f101 + f011 + f001) + (1 - h1) * (f112 + f102 + f012 + f002)))
  
  Speci2 <- expression((h1 * (g001 + g101) + (1 - h1) * (g002 + g102)) / (h1 * (g111 + g101 + g011 + g001) + (1 - h1) * (g112 + g102 + g012 + g002)))

  dSensi1f111 <- deriv(Sensi1, "f111")
  dSensi1f101 <- deriv(Sensi1, "f101")
  dSensi1f011 <- deriv(Sensi1, "f011")
  dSensi1f001 <- deriv(Sensi1, "f001")
  
  dSensi1f112 <- deriv(Sensi1, "f112")
  dSensi1f102 <- deriv(Sensi1, "f102")
  dSensi1f012 <- deriv(Sensi1, "f012")
  dSensi1f002 <- deriv(Sensi1, "f002")
  
  dSensi1h1 <- deriv(Sensi1, "h1")

  dSpeci1g111 <- deriv(Speci1, "g111")
  dSpeci1g101 <- deriv(Speci1, "g101")
  dSpeci1g011 <- deriv(Speci1, "g011")
  dSpeci1g001 <- deriv(Speci1, "g001")
  
  dSpeci1g112 <- deriv(Speci1, "g112")
  dSpeci1g102 <- deriv(Speci1, "g102")
  dSpeci1g012 <- deriv(Speci1, "g012")
  dSpeci1g002 <- deriv(Speci1, "g002")
  
  dSpeci1h1 <- deriv(Speci1, "h1")
  
  dSensi2f111 <- deriv(Sensi2, "f111")
  dSensi2f101 <- deriv(Sensi2, "f101")
  dSensi2f011 <- deriv(Sensi2, "f011")
  dSensi2f001 <- deriv(Sensi2, "f001")
  
  dSensi2f112 <- deriv(Sensi2, "f112")
  dSensi2f102 <- deriv(Sensi2, "f102")
  dSensi2f012 <- deriv(Sensi2, "f012")
  dSensi2f002 <- deriv(Sensi2, "f002")

  dSensi2h1 <- deriv(Sensi2, "h1")
  
  dSpeci2g111 <- deriv(Speci2, "g111")
  dSpeci2g101 <- deriv(Speci2, "g101")
  dSpeci2g011 <- deriv(Speci2, "g011")
  dSpeci2g001 <- deriv(Speci2, "g001")
  
  dSpeci2g112 <- deriv(Speci2, "g112")
  dSpeci2g102 <- deriv(Speci2, "g102")
  dSpeci2g012 <- deriv(Speci2, "g012")
  dSpeci2g002 <- deriv(Speci2, "g002")

  dSpeci2h1 <- deriv(Speci2, "h1")

  f111 <- s111 / n1
  f101 <- s101 / n1
  f011 <- s011 / n1
  f001 <- s001 / n1
  
  g111 <- r111 / n1
  g101 <- r101 / n1
  g011 <- r011 / n1
  g001 <- r001 / n1
  
  f112 <- s112 / n2
  f102 <- s102 / n2
  f012 <- s012 / n2
  f002 <- s002 / n2
    
  g112 <- r112 / n2
  g102 <- r102 / n2
  g012 <- r012 / n2
  g002 <- r002 / n2
  
  h1 <- n1 / n
  
  Se11 <- (f111 + f101) / (f111 + f101 + f011 + f001)
  Sp11 <- (g011 + g001) / (g111 + g101 + g011 + g001)
  
  Se21 <- (f111 + f011) / (f111 + f101 + f011 + f001)
  Sp21 <- (g101 + g001) / (g111 + g101 + g011 + g001)
  
  Se12 <- (f112 + f102) / (f112 + f102 + f012 + f002)
  Sp12 <- (g012 + g002) / (g112 + g102 + g012 + g002)
  
  Se22 <- (f112 + f012) / (f112 + f102 + f012 + f002)
  Sp22 <- (g102 + g002) / (g112 + g102 + g012 + g002)
  
  VarSe11 <- Se11 * (1 - Se11) / s1
  VarSp11 <- Sp11 * (1 - Sp11) / r1
  
  VarSe21 <- Se21 * (1 - Se21) / s1
  VarSp21 <- Sp21 * (1 - Sp21) / r1
  
  VarSe12 <- Se12 * (1 - Se12) / s2
  VarSp12 <- Sp12 * (1 - Sp12) / r2
  
  VarSe22 <- Se22 * (1 - Se22) / s2
  VarSp22 <- Sp22 * (1 - Sp22) / r2 
  
  p1 <- s1 / n1
  
  p2 <- s2 / n2
   
  p <- p1 * h1 + p2 * (1 - h1)
  
  Se1 <- (p1 * h1 * Se11 + p2 * (1 - h1) * Se12) / p  
  Sp1 <- ((1- p1) * h1 * Sp11 + (1 - p2) * (1 - h1) * Sp12) / (1 - p)
  
  Se2 <- (p1 * h1 * Se21 + p2 * (1 - h1) * Se22) / p    
  Sp2 <- ((1- p1) * h1 * Sp21 + (1 - p2) * (1 - h1) * Sp22) / (1 - p)

  a11 <- attr(eval(dSensi1f111), "gradient")[1]
  a21 <- attr(eval(dSensi1f101), "gradient")[1]
  a31 <- attr(eval(dSensi1f011), "gradient")[1]
  a41 <- attr(eval(dSensi1f001), "gradient")[1]
  
  a12 <- attr(eval(dSensi1f112), "gradient")[1]
  a22 <- attr(eval(dSensi1f102), "gradient")[1]
  a32 <- attr(eval(dSensi1f012), "gradient")[1]
  a42 <- attr(eval(dSensi1f002), "gradient")[1]
  
  b11 <- attr(eval(dSpeci1g111), "gradient")[1]
  b21 <- attr(eval(dSpeci1g101), "gradient")[1]
  b31 <- attr(eval(dSpeci1g011), "gradient")[1]
  b41 <- attr(eval(dSpeci1g001), "gradient")[1]
  
  b12 <- attr(eval(dSpeci1g112), "gradient")[1]
  b22 <- attr(eval(dSpeci1g102), "gradient")[1]
  b32 <- attr(eval(dSpeci1g012), "gradient")[1]
  b42 <- attr(eval(dSpeci1g002), "gradient")[1]

  c11 <- attr(eval(dSensi2f111), "gradient")[1]
  c21 <- attr(eval(dSensi2f101), "gradient")[1]
  c31 <- attr(eval(dSensi2f011), "gradient")[1]
  c41 <- attr(eval(dSensi2f001), "gradient")[1]
  
  c12 <- attr(eval(dSensi2f112), "gradient")[1]
  c22 <- attr(eval(dSensi2f102), "gradient")[1]
  c32 <- attr(eval(dSensi2f012), "gradient")[1]
  c42 <- attr(eval(dSensi2f002), "gradient")[1]
  
  d11 <- attr(eval(dSpeci2g111), "gradient")[1]
  d21 <- attr(eval(dSpeci2g101), "gradient")[1]
  d31 <- attr(eval(dSpeci2g011), "gradient")[1]
  d41 <- attr(eval(dSpeci2g001), "gradient")[1]
  
  d12 <- attr(eval(dSpeci2g112), "gradient")[1]
  d22 <- attr(eval(dSpeci2g102), "gradient")[1]
  d32 <- attr(eval(dSpeci2g012), "gradient")[1]
  d42 <- attr(eval(dSpeci2g002), "gradient")[1]
  
  e1 <- attr(eval(dSensi1h1), "gradient")[1]
  e2 <- attr(eval(dSpeci1h1), "gradient")[1]
  e3 <- attr(eval(dSensi2h1), "gradient")[1]
  e4 <- attr(eval(dSpeci2h1), "gradient")[1]
  
  matderi <- matrix(0, 4, 16)

  matderi[1, 1] <- a11
  matderi[1, 2] <- a21
  matderi[1, 3] <- a31
  matderi[1, 4] <- a41
   
  matderi[1, 9] <- a12
  matderi[1, 10] <- a22
  matderi[1, 11] <- a32
  matderi[1, 12] <- a42
  
  matderi[2, 5] <- b11
  matderi[2, 6] <- b21
  matderi[2, 7] <- b31
  matderi[2, 8] <- b41
  
  matderi[2, 13] <- b12
  matderi[2, 14] <- b22
  matderi[2, 15] <- b32
  matderi[2, 16] <- b42
  
  matderi[3, 1] <- c11
  matderi[3, 2] <- c21
  matderi[3, 3] <- c31
  matderi[3, 4] <- c41
  
  matderi[3, 9] <- c12
  matderi[3, 10] <- c22
  matderi[3, 11] <- c32
  matderi[3, 12] <- c42
  
  matderi[4, 5] <- d11
  matderi[4, 6] <- d21
  matderi[4, 7] <- d31
  matderi[4, 8] <- d41
  
  matderi[4, 13] <- d12
  matderi[4, 14] <- d22
  matderi[4, 15] <- d32
  matderi[4, 16] <- d42
  
  Varh1 <- h1 * (1 - h1) / n

  vec1 <- vector("numeric", 8)

  vec1[1] <- f111
  vec1[2] <- f101
  vec1[3] <- f011
  vec1[4] <- f001
  
  vec1[5] <- g111
  vec1[6] <- g101
  vec1[7] <- g011
  vec1[8] <- g001

  mat1 <- matrix(0, 8, 8)

  mat1[1,1] <- f111
  mat1[2,2] <- f101
  mat1[3,3] <- f011
  mat1[4,4] <- f001
  
  mat1[5,5] <- g111
  mat1[6,6] <- g101
  mat1[7,7] <- g011
  mat1[8,8] <- g001

  sigma1 <- matrix(0, 8, 8)
  
  sigma1 <- (1 / n1) * (mat1 - vec1 %*% t(vec1))
  
  vec2 <- vector("numeric", 8)

  vec2[1] <- f112
  vec2[2] <- f102
  vec2[3] <- f012
  vec2[4] <- f002
  
  vec2[5] <- g112
  vec2[6] <- g102
  vec2[7] <- g012
  vec2[8] <- g002

  mat2 <- matrix(0, 8, 8)

  mat2[1,1] <- f112
  mat2[2,2] <- f102
  mat2[3,3] <- f012
  mat2[4,4] <- f002
  
  mat2[5,5] <- g112
  mat2[6,6] <- g102
  mat2[7,7] <- g012
  mat2[8,8] <- g002

  sigma2 <- matrix(0, 8, 8)
  
  sigma2 <- (1 / n2) * (mat2 - vec2 %*% t(vec2))
  
  matrixsigma <- matrix(0, 16, 16)
  
  for (i in 1:8)
   {
    for (j in 1:8)
     {
      matrixsigma[i, j] <- sigma1[i, j]
      }
    }
    
  for (i in 9:16)
   {
    for (j in 9:16)
     {
      matrixsigma[i, j] <- sigma2[i - 8, j - 8]
      }
    }
    
  vec3 <- vector("numeric", 4) 
  
  vec3[1] <- e1
  vec3[2] <- e2
  vec3[3] <- e3
  vec3[4] <- e4
  
  matVar1 <- matrix(0, 4, 4)
               
  matVar1 <- Varh1 * (vec3 %*% t(vec3))
  
  matVar2 <- matrix(0, 4, 4)
             
  matVar2 <- matderi %*% matrixsigma %*% t(matderi)
  
  matVar <- matrix(0, 4, 4) 
  
  matVar <- matVar1 + matVar2 
    
  if (det(matVar) == 0)
    {
      stop("There are many frequencies equal to 0. Introduces new values \n")
    } 

  # Global hypothesis test
  
  matrixA <- matrix(0, 2, 4)
  
  matrixA[1, 1] <- 1
  matrixA[1, 3] <- -1
  matrixA[2, 2] <- 1
  matrixA[2, 4] <- -1
  
  accu <- vector("numeric", 4)
  
  accu[1] <- Se1
  accu[2] <- Sp1
  accu[3] <- Se2
  accu[4] <- Sp2   
  
  Q <-  t(accu) %*% t(matrixA) %*% solve(matrixA %*% matVar %*% t(matrixA)) %*% matrixA %*% accu

  globalpvalue <- (1 - pchisq(Q, 2))

  # Marginal hypothesis tests
  z1 <- abs(Se1 - Se2) / sqrt(matVar[1, 1] + matVar[3, 3] - 2 * matVar[1, 3])
  pvalue1 <- 2 * (1 - pnorm(z1, 0, 1))
  
  LciSe <- Se1 - Se2 - z * sqrt(matVar[1, 1] + matVar[3, 3] - 2 * matVar[1, 3])
  UciSe <- Se1 - Se2 + z * sqrt(matVar[1, 1] + matVar[3, 3] - 2 * matVar[1, 3])

  z2 <- abs(Sp1 - Sp2) / sqrt(matVar[2, 2] + matVar[4, 4] - 2 * matVar[2, 4])
  pvalue2 <- 2 * (1 - pnorm(z2, 0, 1))
  
  LciSp <- Sp1 - Sp2 - z * sqrt(matVar[2, 2] + matVar[4, 4] - 2 * matVar[2, 4])
  UciSp <- Sp1 - Sp2 + z * sqrt(matVar[2, 2] + matVar[4, 4] - 2 * matVar[2, 4])
  
  minpvalue <- min(pvalue1, pvalue2)
  maxpvalue <- max(pvalue1, pvalue2)

  #Results
  sink("results_scapbc.txt", split=TRUE)
  cat("\n")
  cat("     ESTIMATES: FIRST COVARIATE PATTERN \n")
  cat("\n")
  cat("Sensitivity of Test 1 is ", Se11," and its standard error is ", sqrt(VarSe11), "\n")
  cat("\n")
  cat("Specificity of Test 1 is ", Sp11," and its standard error is ", sqrt(VarSp11), "\n")
  cat("\n")
  cat("Sensitivity of Test 2 is ", Se21," and its standard error is ", sqrt(VarSe21), "\n")
  cat("\n")  
  cat("Specificity of Test 2 is ", Sp21," and its standard error is ", sqrt(VarSp21), "\n")
  cat("\n")
  cat("Prevalence is ", p1, "\n")
  cat("\n")
  cat("Probability of having the pattern is ", h1, "\n")
  cat("\n")
  cat("\n")
  cat("     ESTIMATES: SECOND COVARIATE PATTERN \n")
  cat("\n")
  cat("Sensitivity of Test 1 is ", Se12," and its standard error is ", sqrt(VarSe12), "\n")
  cat("\n")
  cat("Specificity of Test 1 is ", Sp12," and its standard error is ", sqrt(VarSp12), "\n")
  cat("\n")
  cat("Sensitivity of Test 2 is ", Se22," and its standard error is ", sqrt(VarSe22), "\n")
  cat("\n")  
  cat("Specificity of Test 2 is ", Sp22," and its standard error is ", sqrt(VarSp22), "\n")
  cat("\n")
  cat("Prevalence is ", p2, "\n")
  cat("\n")
  cat("Probability of having the pattern is ", 1 - h1, "\n")
  cat("\n")
  cat("\n")
  cat("     OVERALL ESTIMATES \n")
  cat("\n")
  cat("Overall sensitivity of Test 1 is ", Se1," and its standard error is ", sqrt(matVar[1, 1]), "\n")
  cat("\n")
  cat("Overall specificity of Test 1 is ", Sp1," and its standard error is ", sqrt(matVar[2, 2]), "\n")
  cat("\n")
  cat("Overall sensitivity of Test 2 is ", Se2," and its standard error is ", sqrt(matVar[3, 3]), "\n")
  cat("\n")  
  cat("Overall specificity of Test 2 is ", Sp2," and its standard error is ", sqrt(matVar[4, 4]), "\n")
  cat("\n")
  cat("Overall prevalence is ", p, "\n")
  cat("\n") 

  if (n < 200)
    {
      cat("\n")
      cat("     INDIVIDUAL HYPOTHESIS TESTS ALONG WITH THE BONFERRONI METHOD", "\n")
      cat("\n")
      cat("Comparison of the two sensitivities: test statistic is ", z1," and the two-sided p-value is ", pvalue1, "\n")
      cat("\n")
      cat("Comparison of the two specificities: test statistic is ", z2," and the two-sided p-value is ", pvalue2, "\n")
      cat("\n")
      cat("\n") 
      cat("     Bonferroni method with alpha error equal to ", alpha, "\n")
      cat("\n")       
      if (pvalue1 <= alpha / 2)
        {
          cat("Null hypothesis H0: Se1 = Se2 is rejected", "\n")
          cat("\n")
          cat(100 * (1 - alpha),"% confidence interval for Se1 - Se2 is: (", LciSe," ; ", UciSe, ") \n")
          cat("\n") 
        }
      else
        {
          cat("Null hypothesis H0: Se1 = Se2 is not rejected", "\n")
          cat("\n")  
        } 
           
      if (pvalue2 <= alpha / 2)
        {
          cat("Null hypothesis H0: Sp1 = Sp2 is rejected", "\n")
          cat("\n")
          cat(100 * (1 - alpha),"% confidence interval for Sp1 - Sp2 is: (", LciSp," ; ", UciSp, ") \n")
          cat("\n")  
        }
      else
        {
          cat("Null hypothesis H0: Sp1 = Sp2 is not rejected", "\n") 
          cat("\n") 
        } 
    }
  
  if (n >= 200)
    {
      cat("\n")
      cat("     GLOBAL HYPOTHESIS TEST",  "\n")
      cat("\n")
      cat("Alpha error is ", alpha, "\n")
      cat("\n")
      cat("The test statistic for the global hypothesis test is ", Q, " and the p-value is ", globalpvalue, "\n")
      cat("\n")
      
      if (globalpvalue > alpha)
        {
          cat("Null hypothesis H0: (Se1 = Se2 and Sp1 = Sp2) is not rejected", "\n")
          cat("\n") 
        }
      else
        {
          cat("Null hypothesis H0: (Se1 = Se2 and Sp1 = Sp2) is rejected", "\n")
          cat("\n")
          cat("     Causes of the significance: Bonferroni method", "\n")
          cat("\n")
          cat("Comparison of the two sensitivities: test statistic is ", z1," and the two-sided p-value is ", pvalue1, "\n")
          cat("\n")
          if (pvalue1 <= alpha / 2)
            {
              cat("Null hypothesis H0: Se1 = Se2 is rejected", "\n")
              cat("\n")
              cat(100 * (1 - alpha),"% confidence interval for Se1 - Se2 is: (", LciSe," ; ", UciSe, ") \n")
              cat("\n") 
            }
          else
            {
              cat("Null hypothesis H0: Se1 = Se2 is not rejected", "\n")
              cat("\n")  
            }
          cat("Comparison of the two specificities: test statistic is ", z2," and the two-sided p-value is ", pvalue2, "\n")
          cat("\n")                   
          if (pvalue2 <= alpha / 2)
            {
              cat("Null hypothesis H0: Sp1 = Sp2 is rejected", "\n")
              cat("\n")
              cat(100 * (1 - alpha),"% confidence interval for Sp1 - Sp2 is: (", LciSp," ; ", UciSp, ") \n")
              cat("\n")  
            }
          else
            {
              cat("Null hypothesis H0: Sp1 = Sp2 is not rejected", "\n") 
              cat("\n") 
            }      
        }
    }
  sink()  
}